package top.luckysmile.mqtt.client.server;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JOptionPane;

import org.eclipse.paho.client.mqttv3.MqttClient;

import top.luckysmile.mqtt.client.data.MqttDAO;
import top.luckysmile.mqtt.client.data.MqttSetBeans;
import top.luckysmile.mqtt.client.listen.MqttClientCallback;
import top.luckysmile.mqtt.client.view.MQTTChatView;
import top.luckysmile.mqtt.client.view.MainView;
/**
 * з
 * @author minuy
 *
 */
public class MqttServerManage {
	private ViewOpt vo;//ͼ
	private ChatViewOpt cvo;//Ựͼ
	private boolean isConnet = false;//״̬
	private MqttClient MC;//ͻ˶
	private List<MQTTChatView> chatSession = new ArrayList<MQTTChatView>();//Ựͼб
	private List<String> subTopic = new ArrayList<String>();//Ѷб

	private static MqttServerManage msm = null;

	/**
	 * 
	 */
	private  MqttServerManage() {
		this.cvo = ChatViewOpt.getChatViewOpt();
	}

	/**
	 * һڲͼǰҪpublic void setViewOpt(MainView mv)ñͼ
	 * @return һ
	 */
	public static MqttServerManage GetMqttServerManage() {
		if(msm != null) {
			return msm;
		}else {
			msm = new MqttServerManage();
			return msm;
		}
	}

	/**
	 * һͼ
	 * @param mv
	 */
	public void setViewOpt(MainView mv) {
		this.vo = new ViewOpt(mv);
	}


	/**
	 * MQTT
	 */
	public void MqttConnet() {
		if(isConnet) {
			//Ͽ
			new MqttClientCloseConnet(MC,vo,this);
			//ն
			SubEmpty();
		}else {
			//
			MqttSetBeans set = vo.getMainViewData();//ȡ 

			MqttClientConnet mqttClient = new MqttClientConnet(set,vo,this);
			mqttClient.start();//
			
			//
			new MqttDAO().SaveSet(set);
		}
	}

	/**
	 * ߵԶⷢ
	 */
	public void MqttPubCustomTopic() {
		MqttSetBeans set = vo.getMainViewData();//ȡ
		MqttSendPub send = new MqttSendPub(set,MC);
		vo.SetSendSta(true);//
		send.start();
	}

	/**
	 * MQTT
	 */
	public void MqttSub() {
		MQTTChatView mcv = null;
		MqttSetBeans set = vo.getMainViewData();//ȡ
		boolean isCreat = false;
		//ֹظ
		System.out.println("ظ......");
		for (int i = 0; i < subTopic.size(); i++) {
			//бȽ
			if(set.getSubTopic().equals(subTopic.get(i))) {
				JOptionPane.showMessageDialog(null, "Ѷģ");
				return;
			}
		}
		
		//ỰͼǷڣٴ
		for (int i = 0; i < chatSession.size(); i++) {
			if(set.getSubTopic().equals(chatSession.get(i).getJlbChatTopic().getText())) {
				isCreat = true;
				mcv = chatSession.get(i);
			}
		}
		
		MqttSubServer sub = new MqttSubServer(set,vo,MC,this,isCreat,mcv);
		sub.start();
		
		//
		new MqttDAO().SaveSet(set);
	}

	/**
	 * ID
	 */
	public void RandId() {
		String id = new GeneratePassword().get(8);
		vo.SetClictID(id);
	}

	/**
	 * ѯ״̬
	 * @return ״̬trueӣfalseδ
	 */
	public boolean isConnet() {
		return isConnet;
	}

	/**
	 * ״̬
	 * @param isConnet true:ӣfalseδ
	 */
	public void setConnet(boolean isConnet) {
		this.isConnet = isConnet;
	}

	/**
	 * ӵĿͻ˶ӳɹ̵߳÷ؿͻ˶
	 * @param mC ӵĿͻ
	 */
	public void setMC(MqttClient mC) {
		MC = mC;
		if(MC.isConnected()) {
			MC.setCallback(new MqttClientCallback(vo,this));
			System.out.println("ӳɹ...");
		}
	}

	/**
	 * ½ĻỰͼ浽б
	 * @param newView
	 */
	public void addSession(MQTTChatView newView) {
		chatSession.add(newView);
	}
	
	/**
	 * ͼбɾһͼ
	 * @param newView
	 */
	public void removeSession(MQTTChatView rmView) {
		for (int i = 0; i < chatSession.size(); i++) {
			if(chatSession.get(i) == rmView) {
				chatSession.remove(i);
				break;
			}
		}
	}


	/**
	 * ұߵԶⷢ
	 */
	public void SessionSend(MQTTChatView mcv) {
		String[] sendData;
		sendData = cvo.getSendInfo(mcv);
		MqttSendPub send = new MqttSendPub(sendData,MC);
		send.start();
	}

	/**
	 * Ự
	 * @param mcv
	 */
	public void CleanSession(MQTTChatView mcv) {
		cvo.CleanSession(mcv);
	}

	/**
	 * رջỰ
	 * ȡ
	 * @param mcv
	 */
	public void CloseSession(MQTTChatView mcv) {
		new closeTopic(vo, MC, chatSession, mcv,this);
	}

	/**
	 * յϢ
	 * @param topic
	 * @param string
	 */
	public void MqttReceveMassage(String topic, String string, String qos) {
		for (int i = 0; i < chatSession.size(); i++) {
			if(chatSession.get(i).getJlbChatTopic().getText().equals(topic)) {
				cvo.AddMassage(string, chatSession.get(i),qos);//Ự
				cvo.addBitNumber(chatSession.get(i),TextUtils.getStringLength(string));//
				break;
			}
		}
	}

	/**
	 * һ
	 */
	public void SubAdd(String topic) {
		subTopic.add(topic);
	}

	/**
	 * ͨɾһ
	 */
	public void SubDrop(String topic) {
		for (int i = 0; i < subTopic.size(); i++) {
			if(topic.equals(subTopic.get(i))) {
				subTopic.remove(i);
			}
		}
	}

	/**
	 * ؽб
	 */
	public void SubEmpty() {
		subTopic = new ArrayList<String>();
		//ȡİť
		for (int i = 0; i < chatSession.size(); i++) {
			chatSession.get(i).SetSubEnable(false);
		}
	}

}
